package cn.com.qmth.stmms.ms.core.specification;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.Predicate;

import org.springframework.data.jpa.domain.Specification;

import cn.com.qmth.stmms.ms.commons.utils.specification.PagingAndSortingSpecification;
import cn.com.qmth.stmms.ms.core.domain.Student;

public class StudentSpecification extends PagingAndSortingSpecification {

    private String workId;
    private String areaCode;
    private String examNumber;
    private String name;
    private String uploadStatus;
    private Boolean isAbsent;

    public String getWorkId() {
		return workId;
	}

	public void setWorkId(String workId) {
		this.workId = workId;
	}

    public String getAreaCode() {
		return areaCode;
	}

	public void setAreaCode(String areaCode) {
		this.areaCode = areaCode;
	}

	public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getExamNumber() {
		return examNumber;
	}

	public void setExamNumber(String examNumber) {
		this.examNumber = examNumber;
	}

	public Boolean getIsAbsent() {
		return isAbsent;
	}

	public void setIsAbsent(Boolean isAbsent) {
		this.isAbsent = isAbsent;
	}

	public String getUploadStatus() {
		return uploadStatus;
	}

	public void setUploadStatus(String uploadStatus) {
		this.uploadStatus = uploadStatus;
	}

	@Override
    public Specification<Student> getSpecification(){
        return (root, query, cb) -> {
            List<Predicate> predicates = new ArrayList<Predicate>();
            if(getName() != null){
                predicates.add(cb.like(root.get("name"), "%"+getName()+"%"));
            }
            if(getExamNumber() != null){
                predicates.add(cb.like(root.get("examNumber"),"%"+getExamNumber()+"%"));
            }
            if(getWorkId() != null){
                predicates.add(cb.equal(root.get("workId"),getWorkId()));
            }
            if(getAreaCode() != null){
                predicates.add(cb.equal(root.get("areaCode"),getAreaCode()));
            }
            if(getIsAbsent()!= null){
                predicates.add(cb.equal(root.get("isAbsent"),getIsAbsent()));
            }
            if(getUploadStatus() != null){
                predicates.add(cb.like(root.get("uploadStatus"),"%"+getUploadStatus()+"%"));
            }
            return cb.and(predicates.toArray(new Predicate[predicates.size()]));
        };
    }
}